close all
clc
clear

rng('default')
K=20; %iterations per N


%Graph of N vs Time (MP verses Matpower)
i=0;
c=5;
for N=20:4:100
    i=i+1;
    tM(i)=0;
    tS(i)=0;
    TCM(i)=0;
    TCS(i)=0;
    eN(i)=0;

    for k=1:K
    
    stop=0;
    Worked=1;
    while Worked>0
    [Lambda]=zCreateLambdaFixed(N,10,-3); %gen must be twice con
 
    G = zCreateRandRegGraph(N,c);
    [Links]=zSparseNetworkMatrixIntoLinks(G,N);
    
    [SatisfiedS, EdgesS, TimeS, TotalSat, TotalLam,t,Worked ]=SimpleBackward(Lambda,Links,6000);
    stop=stop+1;
    if stop>20
        break
    end
    end
    CreateCase(Links,Lambda,k);
        
    a=['mycase' num2str(N) num2str(k)];
    [SatisfiedM, EdgesM, TimeM] = runopf(a);
    tM(i)=tM(i)+TimeM;
    tS(i)=tS(i)+TimeS;
    TCM(i)=TCM(i)+sum(EdgesM(:,3).^2);
    TCS(i)=TCS(i)+sum(EdgesS(:,3).^2);
    eN(i)=eN(i)+N;
    end
    tM(i)=tM(i)/K;
    tS(i)=tS(i)/K;
    TCM(i)=TCM(i)/K;
    TCS(i)=TCS(i)/K;
    eN(i)=eN(i)/K;

end

% save('ComparisonPlotfirst10.mat')
% 
% quit
% exit
 
figure(1)
plot(eN,tS,'k-')
hold on 
plot(eN,tM,'r-')

figure(2)
plot(eN,TCS,'ko-')
hold on 
plot(eN,TCM,'r*-')


%Graph of N vs Time (MP verses Matpower)
i=0;
c=7;
for N=20:4:100
    i=i+1;
    tM(i)=0;
    tS(i)=0;
    TCM(i)=0;
    TCS(i)=0;
    eN(i)=0;

    for k=1:K
    
    stop=0;
    Worked=1;
    while Worked>0
    [Lambda]=zCreateLambdaFixed(N,10,-3); %gen must be twice con
 
    G = zCreateRandRegGraph(N,c);
    [Links]=zSparseNetworkMatrixIntoLinks(G,N);
    
    [SatisfiedS, EdgesS, TimeS, TotalSat, TotalLam,t,Worked ]=SimpleBackward(Lambda,Links,6000);
    stop=stop+1;
    if stop>20
        break
    end
    end
    CreateCase(Links,Lambda,k);
        
    a=['mycase' num2str(N) num2str(k)];
    [SatisfiedM, EdgesM, TimeM] = runopf(a);
    tM(i)=tM(i)+TimeM;
    tS(i)=tS(i)+TimeS;
    TCM(i)=TCM(i)+sum(EdgesM(:,3).^2);
    TCS(i)=TCS(i)+sum(EdgesS(:,3).^2);
    eN(i)=eN(i)+N;
    end
    tM(i)=tM(i)/K;
    tS(i)=tS(i)/K;
    TCM(i)=TCM(i)/K;
    TCS(i)=TCS(i)/K;
    eN(i)=eN(i)/K;

end

% save('ComparisonPlotfirst10.mat')
% 
% quit
% exit
 
figure(1)
plot(eN,tS,'k--')
hold on 
plot(eN,tM,'r--')

figure(2)
plot(eN,TCS,'ko--')
hold on 
plot(eN,TCM,'r*--')

%Graph of N vs Time (MP verses Matpower)
i=0;
c=10;
for N=20:4:100
    i=i+1;
    tM(i)=0;
    tS(i)=0;
    TCM(i)=0;
    TCS(i)=0;
    eN(i)=0;

    for k=1:K
    
    stop=0;
    Worked=1;
    while Worked>0
    [Lambda]=zCreateLambdaFixed(N,10,-3); %gen must be twice con
 
    G = zCreateRandRegGraph(N,c);
    [Links]=zSparseNetworkMatrixIntoLinks(G,N);
    
    [SatisfiedS, EdgesS, TimeS, TotalSat, TotalLam,t,Worked ]=SimpleBackward(Lambda,Links,6000);
    stop=stop+1;
    if stop>20
        break
    end
    end
    CreateCase(Links,Lambda,k);
        
    a=['mycase' num2str(N) num2str(k)];
    [SatisfiedM, EdgesM, TimeM] = runopf(a);
    tM(i)=tM(i)+TimeM;
    tS(i)=tS(i)+TimeS;
    TCM(i)=TCM(i)+sum(EdgesM(:,3).^2);
    TCS(i)=TCS(i)+sum(EdgesS(:,3).^2);
    eN(i)=eN(i)+N;
    end
    tM(i)=tM(i)/K;
    tS(i)=tS(i)/K;
    TCM(i)=TCM(i)/K;
    TCS(i)=TCS(i)/K;
    eN(i)=eN(i)/K;

end

% save('ComparisonPlotfirst10.mat')
% 
% quit
% exit
 
figure(1)
plot(eN,tS,'k:')
hold on 
plot(eN,tM,'r:')

figure(2)
plot(eN,TCS,'ko:')
hold on 
plot(eN,TCM,'r*:')
